"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  default: () => src_default
});
module.exports = __toCommonJS(src_exports);
function getHighlightAPI() {
  if (globalThis.highlight === void 0) {
    throw new Error(
      "Your web app must be running in the Highlight app to use this module. Please see https://docs.highlight.ing for more details."
    );
  }
  return globalThis.highlight;
}
function awaitNextTextPrediction(id) {
  const api2 = getHighlightAPI();
  return new Promise((resolve) => {
    const updateDestructor = api2.app.addListener("onTextPredictionUpdate", (message) => {
      if (message.id !== id) {
        return;
      }
      onDone(message.text);
    });
    const doneDestructor = api2.app.addListener("onTextPredictionDone", (message) => {
      if (message.id !== id) {
        return;
      }
      onDone("");
    });
    function onDone(text) {
      updateDestructor();
      doneDestructor();
      resolve(text);
    }
  });
}
var api = {
  appStorage: {
    isHydrated: () => getHighlightAPI().appStorage.isHydrated(),
    whenHydrated: () => getHighlightAPI().appStorage.whenHydrated(),
    all: () => getHighlightAPI().appStorage.all(),
    get: (key) => getHighlightAPI().appStorage.get(key),
    set: (key, value) => getHighlightAPI().appStorage.set(key, value),
    setAll: (value) => getHighlightAPI().appStorage.setAll(value),
    delete: (key) => getHighlightAPI().appStorage.delete(key),
    clear: () => getHighlightAPI().appStorage.clear()
  },
  app: {
    hasDesktopShortcut: () => getHighlightAPI().app.hasDesktopShortcut(),
    requestCreateDesktopShortcut: () => getHighlightAPI().app.requestCreateDesktopShortcut(),
    setBackgroundStatus: (status) => getHighlightAPI().app.setBackgroundStatus(status),
    getHotkey: () => getHighlightAPI().app.getHotkey(),
    addListener: (event, listener) => getHighlightAPI().app.addListener(event, listener),
    openApp: (appId) => getHighlightAPI().app.openApp(appId)
  },
  permissions: {
    requestBackgroundPermission: () => getHighlightAPI().permissions.requestBackgroundPermission(),
    requestClipboardReadPermission: () => getHighlightAPI().permissions.requestClipboardReadPermission(),
    requestScreenshotPermission: () => getHighlightAPI().permissions.requestScreenshotPermission()
  },
  user: {
    getFacts: () => getHighlightAPI().user.getFacts(),
    getAudio: (longAudio) => getHighlightAPI().user.getAudio(longAudio),
    getAudioForDuration: (duration) => getHighlightAPI().user.getAudioForDuration(duration),
    setAsrRealtime: (isActive) => getHighlightAPI().user.setAsrRealtime(isActive),
    getMicActivity: (lastNumMs) => getHighlightAPI().user.getMicActivity(lastNumMs),
    getScreenshot: () => getHighlightAPI().user.getScreenshot(),
    getEmail: () => getHighlightAPI().user.getEmail(),
    getContext: () => getHighlightAPI().user.getContext(),
    getClipboardContents: () => getHighlightAPI().user.getClipboardContents(),
    getDisplayScreenshots: () => getHighlightAPI().user.getDisplayScreenshots(),
    getWindows: () => getHighlightAPI().user.getWindows(),
    getWindowScreenshot: (windowTitle) => getHighlightAPI().user.getWindowScreenshot(windowTitle)
  },
  auth: {
    signIn: () => getHighlightAPI().auth.signIn()
  },
  inference: {
    getTextPrediction: async function* (messages) {
      const api2 = getHighlightAPI();
      const id = await api2.internal.getTextPrediction(messages);
      let done = false;
      const destructor = api2.app.addListener("onTextPredictionDone", (message) => {
        if (message.id !== id) {
          return;
        }
        done = true;
      });
      while (!done) {
        const next = await awaitNextTextPrediction(id);
        if (next) {
          yield next;
        }
      }
      destructor();
    }
  },
  addEventListener: (event, listener) => {
    getHighlightAPI().addEventListener(event, listener);
  },
  removeEventListener: (event, listener) => {
    getHighlightAPI().removeEventListener(event, listener);
  },
  once: (event, listener) => {
    getHighlightAPI().once(event, listener);
  },
  isRunningInHighlight: () => {
    return globalThis.highlight !== void 0;
  }
};
var src_default = api;
//# sourceMappingURL=index.cjs.map